// Detector.h: interface for the Detector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DETECTOR_H__338D3ED7_2EE5_4DD1_9434_3E210AB4E60C__INCLUDED_)
#define AFX_DETECTOR_H__338D3ED7_2EE5_4DD1_9434_3E210AB4E60C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include <string>
#include <fstream>
#include <vector>
#include "Truck.h"
#include "Car.h"

	/**A base class from which other, specific detectors are derived*/

class Detector  
{
public:
	bool getDirPos();
	Detector();
	virtual ~Detector();
	
	virtual void EndOutput() {};
	virtual void addVehicle(Vehicle* pVeh, double curTime) {};
	
	void	CheckForOutputTime(double step);
	int		getLocation();
	WORD	getDetectorType();

protected:
	virtual void InitOutputFiles() {};
	virtual void doIntervalOutput() {};
	virtual void ReInit() {};

	std::string MapDirToString(bool DirPos);
	std::string MapDetVehTypeToString(WORD VehType);
	double	FindDetectorArrivalTime(Vehicle* pVeh, const double curTime);
	
	WORD	m_DetectorType;
	int		m_RoadLength;
	bool	m_DirPos;
	int		m_Location;
	int		m_NoLanes;
	WORD	m_VehicleType;
	double	m_CurrentTime;
	double	m_TotalTime;
	double	m_TimeInterval;
	int		m_IntervalNo;
	std::vector<Vehicle*> m_vVehicles;
	std::string m_MetricsDir;
		
};

#endif // !defined(AFX_DETECTOR_H__338D3ED7_2EE5_4DD1_9434_3E210AB4E60C__INCLUDED_)
