#ifndef _DIRECTION_H
#define _DIRECTION_H

#include "stdafx.h"
#include <vector>
#include "Vehicle.h"
#include "Lane.h"

typedef std::vector< std::vector<Vehicle*> > M2D;

	/** A class representing a direction in a road*/

class Direction {

public:
	void clear();
	Direction();
	virtual ~Direction();	
	
	void setRoadSegments(std::vector<RoadSegment*> segments);
	void setOutputDetector(OutputDetector* OutputDet);
	
	OutputDetector* getOutputDetector();
	Lane& getLane(int i);
	int getNoLanes();
	M2D getVehiclesM2D();
	M2D getGlobalPos();
	
	bool update(const double step, const double curTime);
	void init(bool DirPos, OutputDetector* OutDet, bool AllowLaneChange, int RoadLength, bool DriveOnRight);
	void createLanes(int iFirstLane, 
					 std::vector<int> vLaneLengths, 
					 std::vector<Detector*> detectors, 
					 std::vector<RoadSegment*> segments);

private:
	void CheckDetectorTimes(double step);

	bool	m_DriveOnRight;
	bool	m_AllowLaneChanging;
	double	m_RoadLength; 
	bool	m_DirPos;
	int		m_NoLanes;
	
	OutputDetector*				m_pOutputDetector;
	std::vector<Lane>			m_vLanes;
	std::vector<Detector*>		m_vDetectors;
	std::vector<RoadSegment*>	m_vRoadSegments;

};
#endif