#if !defined(AFX_DISTRIBUTION_H__EE052C75_E901_4AB0_85F4_6FA67C4F40C5__INCLUDED_)
#define AFX_DISTRIBUTION_H__EE052C75_E901_4AB0_85F4_6FA67C4F40C5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Distribution.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDistribution

#include "stdafx.h"
#include "MersenneTwister.h"

	/**A class representing a distribution that can be saved to file*/

class CDistribution : public CObject
{
public:
	CDistribution();
	CDistribution(double loc, double sc, double sh);
	virtual ~CDistribution();
	CDistribution(const CDistribution& dist);
	
	DECLARE_SERIAL(CDistribution)

// Attributes
public:

// Operations
public:
	void Serialize(CArchive& ar);

// Implementation
public:
	double GenKeepingCoV(double newLocation);
	double Generate();
	void setShape(double sh);
	void setScale(double sc);
	void setLocation(double loc);
	void setDistributionID(WORD id) ;
	
	WORD getDistributionID() const;
	double getShape() const;
	double getScale() const;
	double getLocation() const;
	
	CDistribution& operator=(const CDistribution &dist);
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

private:
	double GenerateExponential();
	double GenerateLogNormal();
	double GenerateGamma();
	double GenerateGumbel();
	double GeneratePoisson();
	double GenerateGEV();
	double GenerateNormal();
	double BoxMuller();
	
	static MTRand m_RNG;
	const double PI;

	WORD m_DistributionID;
	double m_Location;
	double m_Scale;
	double m_Shape;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DISTRIBUTION_H__EE052C75_E901_4AB0_85F4_6FA67C4F40C5__INCLUDED_)
