#ifndef _DRIVERMODEL_H
#define _DRIVERMODEL_H

#include "stdafx.h"
#include <math.h>
#include "Constants.h"

	/** A base class for representing driver models*/

class DriverModel
{
public:
	DriverModel();
	virtual ~DriverModel();

	virtual double getDesiredVel() = 0;
	virtual double update(double vel, double dist) = 0;
	virtual void setVel(double vel) = 0;
	
	virtual void ClearRestriction() {};
	virtual void ClearGradient() {};
	virtual void SetGradient(double gradient) {};
	virtual void ClearSpeedLimit() {};
	virtual void SetSpeedLimit(double limit) {};

	// double because we want to send back info to let the vehicle decide
	virtual double LaneChange(	double GapToFront, 
								double GapToBack, 
								double FrontChangeAccel,
								double CurrentBackAccel, 
								double ProposedBackAccel, 
								bool overtake) = 0;

protected:
	
	bool m_bInGradient;
	bool m_bInSpeedLimit;
};

#endif
