// EvolveTrafficView.h : interface of the CEvolveTrafficView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVOLVETRAFFICVIEW_H__A8EBCCBD_29B8_4AA3_BF81_C9D991006520__INCLUDED_)
#define AFX_EVOLVETRAFFICVIEW_H__A8EBCCBD_29B8_4AA3_BF81_C9D991006520__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MiscCtrls/ProgressBar.h"
#include "MiscCtrls/ZoomView.h"
#include "MiscCtrls/MessageTip.h"

	/**A class for user interaction and drawing functions*/

class CEvolveTrafficView : public CScrollView
{
protected: // create from serialization only
	CEvolveTrafficView();
	DECLARE_DYNCREATE(CEvolveTrafficView)

// Attributes
public:
	CEvolveTrafficDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEvolveTrafficView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdateProgressBar();
	void doLoop(int curTime);
	void setMaxTimeWarp();
	virtual ~CEvolveTrafficView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CEvolveTrafficView)
	afx_msg void OnConfigSim();
	afx_msg void OnRunVisible();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnConfigTraf();
	afx_msg void OnToolsPrefs();
	afx_msg void OnToolsPause();
	afx_msg void OnToolsZoomin();
	afx_msg void OnToolsZoomout();
	afx_msg void OnToolsSpeedup();
	afx_msg void OnToolsSlowdown();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRunInvisible();
	afx_msg void OnConfigFeatures();
	afx_msg void OnConfigMetrics();
	afx_msg void OnUpdateToolsPause(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolsSpeedup(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolsSlowdown(CCmdUI* pCmdUI);
	afx_msg void OnToolsStop();
	afx_msg void OnUpdateToolsStop(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnFileSaveImage();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	bool m_bShowLegend;
	bool m_bShowVelocity;
	Vehicle* FindVehicle(int iLane, int location);
	BOOL WriteWindowToDIB( LPTSTR szFile, CWnd *pWnd );

	int m_BtmEdge;
	int m_TopEdge;
	int m_nLanesOnBtm;
	int m_nLanesOnTop;
	bool m_DriveOnRight;
	double m_ExaggerateWidths;
	void SetZoomScale(double newScale);
	void ValidateTimeWarp();
	CSize m_DrawArea;

	void doSimStart();
	int m_LastPercentComplete;

	int Round(double val) {return int(val + 0.5);};
	
	void doSimFinished(bool bCompleted);
	void UpdateDrawRegion();
	void SettingUpdateRedraw();

	void initRoad();	
	void DrawRoad(CMemDC *pDC);	
	void DrawRuler(CMemDC *pDC);
	void DrawTimer(CMemDC *pDC);
	void DrawVehicle(CMemDC *pDC, Vehicle* veh);
	void DrawVehicleAt(CMemDC *pDC, WORD VEH_ID, CRect VehRect);
	void DrawDetectors(CMemDC *pDC);
	void DrawLaneChangeDetectors(CMemDC *pDC, bool DirPos);
	void DrawLegend(CMemDC *pDC);
	void DrawLegendElement(CMemDC *pDC, int LineLength, int LineToText, 
							int xpos, int ypos, CString str, COLORREF COL);
	void DrawSingleSegment(CMemDC *pDC, COLORREF COL, WORD HATCH, 
										   WORD FeatType, int val, CRect rect, int yTextOffset);
	void DrawRoadSegments(CMemDC *pDC);
	void DrawSingleDetector(CMemDC *pDC, COLORREF COL, int Loc, bool DirPos);	
	void DrawLegendSegment(CMemDC *pDC, COLORREF COL, WORD HATCH, 
										   WORD FeatType, CString str, int value, int LineToText, int xpos, int ypos);
	void DrawLegendVehicle(CMemDC *pDC, WORD VehType, CString str, int LineToText, int xpos, int ypos);

	double	m_MaxTimeWarp;
	int		m_SimTimeStep;
	int		m_PauseTime;
	int		m_StartRealTime;
	int		m_CurentRealTime;
	double	m_CurentSimTime;
	BOOL	m_bPause;
	int		m_TimerSpeed;
	int		m_PercentComplete;

	CRect	m_ClientRect;
	int		m_YCoordTop;
	RECT	m_RoadRect;
	bool	m_bInSimulation;

	double	m_Scale;
	double	m_TimeWarp;
	double	m_VehicleLengthScale;
	double	m_VehicleWidth;	
	double	m_TickLength;
	int		m_TickStep;
	double	m_LaneWidth;
	double	m_Border_Top;
	double	m_Border_Btm;
	double	m_Border_Lhs;
	double	m_Border_Rhs;

	int		m_NoDirections;
	int		m_NoLanes;
	int		m_NoLanesDirPos;
	int		m_NoLanesDirNeg;
	int		m_RoadLength;	
	int		m_NoTicks;
	int		m_RoadWidth;

	M2D		m_VehiclePositions;
	
	CEvolveTrafficDoc* m_pDoc;
	CProgressBar* m_pProgBar;
	CMessageTip m_DataTip;

	double MIN_VIEW_SCALE;
	double DATATIP_DELAY;

	COLORREF CLR_BACKGRND;
	COLORREF CLR_DET_COMPOSITION;
	COLORREF CLR_DET_FLOWDENSITY;
	COLORREF CLR_DET_HEADWAY;
	COLORREF CLR_DET_OUTPUT;
	COLORREF CLR_FEAT_GRADIENT;
	COLORREF CLR_FEAT_SPEEDLIMIT;
	COLORREF CLR_LEGEND_TEXT;
	COLORREF CLR_ROAD_LINES;
	COLORREF CLR_ROAD_SURFACE;
	COLORREF CLR_RULER_LINES;
	COLORREF CLR_RULER_TEXT;

	COLORREF VEH_COLOR_CAR;
	COLORREF VEH_COLOR_SMALLTRUCK;
	COLORREF VEH_COLOR_LARGETRUCK;
	COLORREF VEH_COLOR_CRANE;
	COLORREF VEH_COLOR_LOWLOADER;
};

#ifndef _DEBUG  // debug version in EvolveTrafficView.cpp
inline CEvolveTrafficDoc* CEvolveTrafficView::GetDocument()
   { return (CEvolveTrafficDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EVOLVETRAFFICVIEW_H__A8EBCCBD_29B8_4AA3_BF81_C9D991006520__INCLUDED_)
