// FileHandler.cpp: implementation of the FileHandler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EvolveTraffic.h"
#include "FileHandler.h"

#include "ConfigData.h"
extern CConfigData g_ConfigData;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

	/** Default Constructor*/
FileHandler::FileHandler()
{
	TRUCK_WEIGHT_THRESHOLD = g_ConfigData.VehicleID.TRUCK_WEIGHT_THRESHOLD;
	
	m_CurLine = 0;
}

	/** Default Destructor*/
FileHandler::~FileHandler()
{

}

	/** Facilitates the buffering of a number of vehicles, rather than line by line input
	 *
	 * @param no The number of vehicles to buffer
	 * @return The buffer of vehicles
	 */
std::vector<Vehicle*> FileHandler::loadTruckGroup(int no)
{
	for(int i = 0; i < no; i++)
	{
		Vehicle* pVeh = readLine();
		m_Vehicles.push_back(pVeh);
	}

	return m_Vehicles;
}

void FileHandler::setInFileSize()
{
    m_InFileSize = std::count(	std::istreambuf_iterator<char>(m_InFile),
								std::istreambuf_iterator<char>(), 
								'\n');
	
	m_InFile.seekg(0,std::ios::beg);	// go back to start of file
}

int FileHandler::getPercentComplete()
{
	double prop = (double)(m_CurLine) / m_InFileSize;

	int percent = int(prop * 100 + 0.5);

	return percent;
}
