// FileHandler.h: interface for the FileHandler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILEHANDLER_H__1D4DB653_00A1_4904_803E_A9AFD95DA75D__INCLUDED_)
#define AFX_FILEHANDLER_H__1D4DB653_00A1_4904_803E_A9AFD95DA75D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include <string>
#include <fstream>
#include <algorithm>
#include "Truck.h"
#include "Car.h"

	/** A base class for handling file input and output */

class FileHandler  
{
public:
	int getPercentComplete();
	std::vector<Vehicle*> loadTruckGroup(int no);
	virtual void writeLine(Vehicle *pVeh) = 0;
	virtual Vehicle* readLine() = 0;
	FileHandler();
	virtual ~FileHandler();

protected:
	void setInFileSize();
	std::ifstream m_InFile;
	std::ofstream m_OutFile;
	std::vector<Vehicle*> m_Vehicles;
	char* m_pCharVeh;
	char m_VehCharArry[78];
	
	int m_CurLine;
	int m_InFileSize;

	int TRUCK_WEIGHT_THRESHOLD;

};

#endif // !defined(AFX_FILEHANDLER_H__1D4DB653_00A1_4904_803E_A9AFD95DA75D__INCLUDED_)
