// LaneChangeDetector.h: interface for the LaneChangeDetector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LaneChangeDetector_H__639DB76E_AAB0_4635_9E5E_2770E45286C3__INCLUDED_)
#define AFX_LaneChangeDetector_H__639DB76E_AAB0_4635_9E5E_2770E45286C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Detector.h"
#include "LaneChangeEvent.h"

	/**A derived class to represent a detector that tracks lane changes*/

class LaneChangeDetector : public Detector
{
public:
	LaneChangeDetector(std::string dir, double dt, double dx, int roadLen,
									   bool DirPos, WORD VehType);
	virtual ~LaneChangeDetector();
	
	virtual void EndOutput();

	void addEvent(LaneChangeEvent* lce);

private:
	virtual void InitOutputFiles();
	virtual void doIntervalOutput();
	virtual void ReInit();

	void InitVerboseFile();
	void InitCompositionFile();
	void InitSpaceTimeFile();
	void InitRateFile();
	
	void doVerboseOutput();
	void doCompositionOutput();
	void doSpaceTimeOutput();
	void doRateOutput();

	void AddCurrentEvent(LaneChangeEvent* lce);	
	
	std::vector<LaneChangeEvent*> m_vChangeEvents;

	std::ofstream m_OutFile_Verbose;
	std::ofstream m_OutFile_Composition;
	std::ofstream m_OutFile_SpaceTime;
	std::ofstream m_OutFile_Rate;

	int m_NoLaneChangeEvents;
	int	m_DistanceInterval;
	int m_NoDistIntervals;
	std::vector<int> m_vDistanceIntervals;
	std::vector<int> m_vDistInt_LCECount;

	std::string m_MetricsDir2;

};

#endif // !defined(AFX_LaneChangeDetector_H__639DB76E_AAB0_4635_9E5E_2770E45286C3__INCLUDED_)
