// LaneChangeEvent.cpp: implementation of the LaneChangeEvent class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "LaneChangeEvent.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

	/**Constructor
	 *
	 * @param pos The position of the event
	 * @param fromLane The lane from which the vehicle changed
	 * @param toLane The lane to which the vehicle changed
	 * @param type The type of vehicle involved
	 * @param moveLeft Whether the vehicle changed into a left lane or not
	 * @param dirPos Whether the vehicle is travelling in a positive direction or not
	 * @param time The time at which the event occured
	 *
	 */
LaneChangeEvent::LaneChangeEvent(int pos, int fromLane, int toLane, int type, bool moveLeft, bool dirPos, double time)
{
	m_EventPosition = pos;
	m_OriginLane = fromLane;
	m_DestinationLane = toLane;
	m_VehType = type;
	m_MovingLeft = moveLeft;
	m_DirPos = dirPos;
	m_EventTime = time;
}

	/**Destructor*/
LaneChangeEvent::~LaneChangeEvent()
{

}

bool LaneChangeEvent::getChangeLeft()
{
	return m_MovingLeft;
}

int LaneChangeEvent::getDestinationLane()
{
	return m_DestinationLane;
}

int LaneChangeEvent::getPosition()
{
	return m_EventPosition;
}

int LaneChangeEvent::getOriginLane()
{
	return m_OriginLane;
}

bool LaneChangeEvent::getDirPos()
{
	return m_DirPos;
}

WORD LaneChangeEvent::getVehicleType()
{
	return m_VehType;
}

double LaneChangeEvent::getTime()
{
	return m_EventTime;
}
