// LaneChangeEvent.h: interface for the LaneChangeEvent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LANECHANGEEVENT_H__96B66F57_CE4E_4E26_A451_345709048732__INCLUDED_)
#define AFX_LANECHANGEEVENT_H__96B66F57_CE4E_4E26_A451_345709048732__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Vehicle.h"

	/**A container class to represent the relevant information from a lane change event*/

class LaneChangeEvent  
{
public:
	double getTime();
	WORD getVehicleType();
	bool getDirPos();
	int getOriginLane();
	int getPosition();
	int getDestinationLane();
	bool getChangeLeft();
	LaneChangeEvent(int pos, int fromLane, int toLane, int type, bool left, bool dirPos, double time);
	virtual ~LaneChangeEvent();

private:
	/**The position of the event*/
	int m_EventPosition;
	/**The lane from which the vehicle changed*/
	int m_OriginLane;
	 /**The lane to which the vehicle changed*/
	int m_DestinationLane;
	 /**The type of vehicle involved*/
	int m_VehType;
	 /**Whether the vehicle changed into a left lane or not*/
	bool m_MovingLeft;
	 /**Whether the vehicle is travelling in a positive direction or not*/
	bool m_DirPos;
	 /**The time at which the event occured*/
	double m_EventTime;
};

#endif // !defined(AFX_LANECHANGEEVENT_H__96B66F57_CE4E_4E26_A451_345709048732__INCLUDED_)
