// MetricsDetector.h: interface for the MetricsDetector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_METRICSDETECTOR_H__06A2EEA5_6E1B_4581_BB61_6FEC99FBABCC__INCLUDED_)
#define AFX_METRICSDETECTOR_H__06A2EEA5_6E1B_4581_BB61_6FEC99FBABCC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Detector.h"

typedef std::vector< std::vector<double> > M2Ddbl;

	/** A derived class to represent a detector that tracks metrics information*/

class MetricsDetector : public Detector  
{
public:
	MetricsDetector(std::string dir, WORD DetType, bool DirPos, int nLanes, WORD VehType, int timeInterval, int loc, int RoadLength);
	virtual ~MetricsDetector();
	
	virtual void EndOutput();
	
	virtual void addVehicle(Vehicle* pVeh, double curTime);

private:
	virtual void InitOutputFiles();
	virtual void doIntervalOutput();	
	virtual void ReInit();
	
	void InitCompositionFile();
	void InitHeadwayFile();
	void InitFlowDensityFile();
	
	void doCompositionOutput();
	void doHeadwayOutput();
	void doFlowDensityOutput();
	
	void	AddCurrentVehicle(Vehicle* pVeh, const double curTime);
	void	initVectors();
	std::string intToString(int d);
	
	double				m_AvgVel;
	std::ofstream		m_OutFile;
	std::vector<WORD>	m_vVehicleTypes;
	M2Ddbl				m_vVelocities;
	M2Ddbl				m_vHeadways;
	std::vector<double> m_vTimeOfLastArrival;
	std::vector<int>	m_vNoVehicles;
};

#endif // !defined(AFX_METRICSDETECTOR_H__06A2EEA5_6E1B_4581_BB61_6FEC99FBABCC__INCLUDED_)
