/////////////////////////////////////////////////////////////////////////////
// CDialogExt.cpp : implementation file
// 
// Author: cunlin zhang
// Date  : February 2001
// Email : zhangcunlin@21cn.com
// Copyright (c) 2001-2003,  All Rights Reserved.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then acknowledgement must be made to the author of this file. 

// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.

#include "stdafx.h"

#include "DialogExt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CDialogExt, CDialog)

/////////////////////////////////////////////////////////////////////////////
// CDialogExt dialog

CDialogExt::CDialogExt() 
{
	m_pWndFrom = NULL;
}
CDialogExt::CDialogExt (UINT nIDTemplate, CWnd *pParent/*= NULL*/) : 
				CDialog (nIDTemplate, pParent) 
{
	m_pWndFrom = NULL;
}
CDialogExt::CDialogExt (LPCTSTR lpszTemplateName, CWnd *pParentWnd/*= NULL*/) : 
				CDialog(lpszTemplateName, pParentWnd) 
{
	m_pWndFrom = NULL;
}

BEGIN_MESSAGE_MAP(CDialogExt, CDialog)
	//{{AFX_MSG_MAP(CDialogExt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogExt message handlers
BOOL CDialogExt::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	
	if (nID == IDOK) // click/press OK button
	{		
		CString strError = _T("");
		UINT nCtrlID = (UINT) -1;
		
		// call virtual function to get error information
		OnValidate(nCtrlID, strError);
		
		if (!strError.IsEmpty() && nCtrlID > 0)
		{
			CWnd *pWnd = GetDlgItem(nCtrlID);
			if (pWnd == NULL) 
				return TRUE;
			
			CWnd * pWndFocus = GetFocus();
			// check to see if show the error message
			if (pWndFocus == pWnd ||
				pWndFocus == pWnd->GetDlgItem(1001) || // 1001 is the ID value for the edit control associated to the combobox      
				pWndFocus == GetDlgItem(IDOK) &&       // click OK button or press Enter key over muti-line edit control
				(m_pWndFrom == NULL || m_pWndFrom == pWnd) 
				)											
			{

				if (!m_tip.GetSafeHwnd())
				{
					m_tip.Create(this);
					if (!m_tip.GetSafeHwnd())
						return TRUE;
				}

				CRect rect;
				pWnd->GetWindowRect(&rect);
				ScreenToClient(&rect);

				// display the error message with beep
				MessageBeep((UINT) -1);
				m_tip.Show(rect, strError);

			}
			m_pWndFrom = NULL;
			pWnd->SetFocus();
			return TRUE;
		}
	}
	return CDialog::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

BOOL CDialogExt::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_RETURN)
	{
		CWnd *pWnd = FromHandle(pMsg->hwnd);
		if (pWnd != GetDlgItem(IDOK)) 
			m_pWndFrom = pWnd;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

// ////////////////////////////////////////////////////////////////////
// [nCtrlID] - ID of erroneous control 
// [strError] - error message text
// virtual function to get error information
void CDialogExt::OnValidate(UINT &nCtrlID, CString &strError)
{
	UNREFERENCED_PARAMETER(nCtrlID);
	UNREFERENCED_PARAMETER(strError);
}

