/////////////////////////////////////////////////////////////////////////////
// MessageTip.h : header file
// 
// Author: cunlin zhang
// Date  : 10 February 2001
// Email : zhangcunlin@21cn.com
// Copyright (c) 2001-2003,  All Rights Reserved.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then acknowledgement must be made to the author of this file. 
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.

#if !defined(_MESSAGETIP_H__INCLUDED__)
#define _MESSAGETIP_H__INCLUDED__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMessageTip window
#include "../stdafx.h"

	/**A class that renders a tooltip anywhere on the screen*/

class CMessageTip : public CWnd
{
// Construction
public:
	CMessageTip();

// Attributes
public:

	void	 SetDisplayTime(int nDisplayTime) { m_nDisplayTime = nDisplayTime; }
    COLORREF GetTipBkColor() const { return m_clrBackColor; };
    void     SetTipBkColor(COLORREF clr) { m_clrBackColor = clr; };
	COLORREF GetTipTextColor() const { return m_clrTextColor; };
    void     SetTipTextColor(COLORREF clr) { m_clrTextColor = clr; };
	void	 SetShadow(BOOL bShadow = TRUE) { m_bShadow  = bShadow; };

// Operations
public:
	
    BOOL Create(CWnd* pParentWnd);
    void Show(LPCRECT lpRect, LPCTSTR lpszTipText);
	void Hide();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMessageTip)
	//}}AFX_VIRTUAL

protected:
    virtual CRect GetBoundsRect(CString strText);
    virtual CRect CalculateInfoBoxRect(CPoint& pt, CRect& rectTextBounds) const;

// Implementation
public:
	virtual ~CMessageTip();

protected:
    BOOL		IsCursorInTipWindow () const;
	CString		GetFieldFromString (CString ref, int nIndex, TCHAR ch) const;
	void		DrawShadows (CDC& dc, const CRect& rectClient);

protected:

    CWnd*		m_pParentWnd;               // Parent window
    CRect		m_rcMargin;					// Margin between text and window edge
    CPoint		m_ptOffset;                 // offset from given point
    CFont		m_Font;						// Current font in use

    int			m_nInterval;				// Time in ms between timer event
    int			m_nDisplayTime;             // Time in ms to display
    int			m_nTimeCount;               // Counter of Elapsed time 

    COLORREF	m_clrBackColor;             // Default background color of tips
    COLORREF	m_clrTextColor;             // Default foreground color of tips

	CString		m_strTipText;				// A CString containing the message tip text

	//-------------------
	// Shadow attributes:
	//-------------------
	BOOL		m_bShadow;			// when TRUE paints shadows 
	int			m_iShadowSize;
	BOOL		m_bSaveShadows;
	CBitmap		m_bmpShadowRight;	// Saved right shadow bitmaps
	CBitmap		m_bmpShadowBottom;  // Saved bottom shadow bitmaps

	//-------------------
	// Hook Static members:
	//-------------------
	static HHOOK			m_hKeyboardHook; // handle to the Keyboard hook
	static HHOOK			m_hMouseHook;	 // handle to the Mouse hook
	static HWND				m_hWndReceiver;
	static void				SetHook( HWND hWnd, BOOL bSetHook = TRUE );
	static LRESULT CALLBACK KeyboardHookProc(int nCode, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK MouseHookProc(int nCode, WPARAM wParam, LPARAM lParam);

protected:
	//{{AFX_MSG(CMessageTip)
	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg int  OnMouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnClose();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(_MESSAGETIP_H__INCLUDED__)
