// OutputDetector.h: interface for the Detector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DETECTOR_H__F90280E9_BFD2_40CF_A999_86FF1E9DDE15__INCLUDED_)
#define AFX_DETECTOR_H__F90280E9_BFD2_40CF_A999_86FF1E9DDE15__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Detector.h"
#include "CASTORFile.h"
#include "SAFTFile.h"

	/** A derived class representing a detector which tracks when vehicles pass a point*/

class OutputDetector  : public Detector
{
public:

	OutputDetector(int loc, bool DirPos, FileHandler* fh);
	virtual ~OutputDetector();
	
	void setFileHandler(FileHandler* fh);
	void WriteVehiclesToFile();
	std::vector<Vehicle*> getVehicles();
	void addVehicle(Vehicle* pVeh, double curTime);

private:
	void clear();
	FileHandler* m_pFileHandler;

};

#endif // !defined(AFX_DETECTOR_H__F90280E9_BFD2_40CF_A999_86FF1E9DDE15__INCLUDED_)
