// RoadFeature.cpp: implementation of the CRoadFeature class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EvolveTraffic.h"
#include "RoadFeature.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (CRoadFeature, CObject, VERSION_NUMBER)

CRoadFeature::CRoadFeature()
{
	m_Type		= FEAT_SPEEDLIMIT;
	m_DirPos	= true;
	m_Start		= 0;
	m_End		= 1000;
	m_Value		= 41.7;	//  in m/s - about 150 km/h!
}

CRoadFeature::~CRoadFeature()
{

}

void CRoadFeature::Serialize(CArchive &ar)
{
    if (ar.IsStoring())
    {
        ar	<< m_Type
			<< static_cast<int>(m_DirPos)	// because I read in an int below
			<< m_Start
			<< m_End
			<< m_Value;
    }
    else
	{
		int temp;
        ar	>> m_Type
			>> temp
			>> m_Start
			>> m_End
			>> m_Value;

		m_DirPos = temp == 0 ? false : true;
	}
}

WORD CRoadFeature::getType()
{
	return m_Type;
}

bool CRoadFeature::getDirPos()
{
	return m_DirPos;
}

int CRoadFeature::getStart()
{
	return m_Start;
}

int CRoadFeature::getEnd()
{
	return m_End;
}

double CRoadFeature::getValue()
{
	return m_Value;
}

void CRoadFeature::setType(WORD type)
{
	m_Type = type;
}

void CRoadFeature::setDirPos(bool dirpos)
{
	m_DirPos = dirpos;
}

void CRoadFeature::setStart(int start)
{
	m_Start = start;
}

void CRoadFeature::setEnd(int end)
{
	m_End = end;
}

void CRoadFeature::setValue(double val)
{
	m_Value = val;
}





