// RoadSegment.cpp: implementation of the RoadSegment class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RoadSegment.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RoadSegment::RoadSegment()
{

}

RoadSegment::~RoadSegment()
{

}

int RoadSegment::getBeginning() const
{
	return m_Beginning;
}

int RoadSegment::getEnd() const
{
	return m_End;
}

void RoadSegment::setBeginning(int beginning)
{
	m_Beginning = beginning;
}

void RoadSegment::setEnd(int end)
{
	m_End = end;
}

void RoadSegment::addVehicle(Vehicle *pVeh)
{

}

void RoadSegment::removeVehicle(Vehicle *pVeh)
{

}

bool RoadSegment::getDirPos()
{
	return m_DirPos;
}

void RoadSegment::setIDMParams_Car(CIDMParameterSet *Params)
{
	m_pIDMParams_Car = Params;
}

void RoadSegment::setIDMParams_Crane(CIDMParameterSet *Params)
{
	m_pIDMParams_Crane = Params;
}

void RoadSegment::setIDMParams_SmallTruck(CIDMParameterSet *Params)
{
	m_pIDMParams_SmallTruck = Params;
}

void RoadSegment::setIDMParams_LargeTruck(CIDMParameterSet *Params)
{
	m_pIDMParams_LargeTruck = Params;
}

void RoadSegment::setIDMParams_Lowloader(CIDMParameterSet *Params)
{
	m_pIDMParams_Lowloader = Params;
}

CIDMParameterSet* RoadSegment::getIDMParams(WORD veh_id)
{
	switch(veh_id)
	{
		case VEH_ID_CAR:
			return m_pIDMParams_Car;
		case VEH_ID_SMALLTRUCK:
			return m_pIDMParams_SmallTruck;
		case VEH_ID_LARGETRUCK:
			return m_pIDMParams_LargeTruck;
		case VEH_ID_CRANE:
			return m_pIDMParams_Crane;
		case VEH_ID_LOWLOADER:
			return m_pIDMParams_Lowloader;
		default:
			return m_pIDMParams_Car;
	}			
}

	/**A function to compare RoadSegments
	 *
	 * @param a The first RoadSegment
	 * @param b The second RoadSegment
	 * @return Whether the first segment's starting point is less than the second.
	 */

bool RoadSegment::CompareSegments(const RoadSegment* a, const RoadSegment* b)
{
	int startA = a->getBeginning();
	int startB = b->getBeginning();
	return startA < startB;
}
