// RoadSegment.h: interface for the RoadSegment class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROADSEGMENT_H__DFD0E9F6_3EB2_47CB_9D5E_408357D1CF04__INCLUDED_)
#define AFX_ROADSEGMENT_H__DFD0E9F6_3EB2_47CB_9D5E_408357D1CF04__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Truck.h"
#include "Car.h"
#include "IDM.h"
#include "IDMParameterSet.h"

	/** A base class from which specific special road segments are derived*/

class RoadSegment  
{
public:
	CIDMParameterSet* getIDMParams(WORD veh_id);
	void setIDMParams_Lowloader(CIDMParameterSet *Params);
	void setIDMParams_LargeTruck(CIDMParameterSet *Params);
	void setIDMParams_SmallTruck(CIDMParameterSet *Params);
	void setIDMParams_Crane(CIDMParameterSet *Params);
	void setIDMParams_Car(CIDMParameterSet* Params);
	bool getDirPos();

	static bool CompareSegments(const RoadSegment* a, const RoadSegment* b);

	virtual void removeVehicle(Vehicle* pVeh);
	virtual void addVehicle(Vehicle* pVeh);
	void setEnd(int end);
	void setBeginning(int beginning);
	int getEnd() const;
	int getBeginning() const;
	RoadSegment();
	virtual ~RoadSegment();

protected:
	int m_Beginning;
	int m_End;
	bool m_DirPos;
	CIDMParameterSet* m_pIDMParams_Car;
	CIDMParameterSet* m_pIDMParams_Crane;
	CIDMParameterSet* m_pIDMParams_SmallTruck;
	CIDMParameterSet* m_pIDMParams_LargeTruck;
	CIDMParameterSet* m_pIDMParams_Lowloader;
};

#endif // !defined(AFX_ROADSEGMENT_H__DFD0E9F6_3EB2_47CB_9D5E_408357D1CF04__INCLUDED_)
