// SimConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EvolveTraffic.h"
#include "SimConfigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSimConfigDlg dialog


CSimConfigDlg::CSimConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialogExt(CSimConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSimConfigDlg)
	m_FileIn = _T("");
	m_RoadLength = 5000;
	m_NoLanesDirPos = 1;
	m_NoLanesDirNeg = 1;
	m_FileType = CASTOR;
	m_SimTimeStep = 100;
	m_TrafFileNoLanesDirPos = -1;
	m_TrafFileNoLanesDirNeg = -1;
	m_FileOut = _T("");
	m_DriveOnRight = true;
	m_LocOutputDetectorDirPos = 0;
	m_LocOutputDetectorDirNeg = 0;
	m_AllowLaneChanging = true;
	m_intDriveSide = -1;
	m_MetricsDir = _T("");
	//}}AFX_DATA_INIT
}


void CSimConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogExt::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimConfigDlg)
	DDX_Text(pDX, IDC_EDT_FILE_IN, m_FileIn);
	DDX_Text(pDX, IDC_EDT_ROADLENGTH, m_RoadLength);
	DDV_MinMaxInt(pDX, m_RoadLength, 500, 100000);
	DDX_CBIndex(pDX, IDC_CMB_LANESDIRPOS, m_NoLanesDirPos);
	DDX_CBIndex(pDX, IDC_CMB_LANESDIRNEG, m_NoLanesDirNeg);
	DDX_Text(pDX, IDC_EDT_SIMTIMESTEP, m_SimTimeStep);
	DDV_MinMaxInt(pDX, m_SimTimeStep, 10, 2000);
	DDX_CBIndex(pDX, IDC_CMB_TRAFFILE_LANESDIR1, m_TrafFileNoLanesDirPos);
	DDX_CBIndex(pDX, IDC_CMB_TRAFFILE_LANESDIR2, m_TrafFileNoLanesDirNeg);
	DDX_Text(pDX, IDC_EDT_FILE_OUT, m_FileOut);
	DDX_Text(pDX, IDC_EDT_DIRPOSDETECTOR, m_LocOutputDetectorDirPos);
	DDX_Text(pDX, IDC_EDT_DIRNEGDETECTOR, m_LocOutputDetectorDirNeg);
	DDX_Check(pDX, IDC_CHECK_LANECHNG, m_AllowLaneChanging);
	DDX_CBIndex(pDX, IDC_CMB_DRIVESIDE, m_intDriveSide);
	DDX_Text(pDX, IDC_EDT_METRICSOUT, m_MetricsDir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSimConfigDlg, CDialogExt)
	//{{AFX_MSG_MAP(CSimConfigDlg)
	ON_BN_CLICKED(IDC_BTN_FILEINPICK, OnBtnFileInPick)
	ON_BN_CLICKED(IDC_BTN_FILEOUTPICK, OnBtnFileOutPick)
	ON_BN_CLICKED(IDC_RAD_CASTOR, OnRadCastor)
	ON_BN_CLICKED(IDC_RAD_SAFT, OnRadSaft)
	ON_CBN_SELCHANGE(IDC_CMB_DRIVESIDE, OnSelchangeCmbDriveside)
	ON_BN_CLICKED(IDC_BTN_METRICSOUT, OnBtnMetricsout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimConfigDlg message handlers

void CSimConfigDlg::OnValidate(UINT &nID, CString &strMessage)
{
	UpdateData();

	CString strFileIn, strFileOut, strNoLanesDirPos, strNoLanesDirNeg;
	CString strSimTimeStep, strTrafFileNoLanesDirPos, strTrafFileNoLanesDirNeg;
	CString strDriveSide, strLocOutputDetectorDirPos, strLocOutputDetectorDirNeg;

	GetDlgItemText(IDC_EDT_FILE_IN, strFileIn);
	GetDlgItemText(IDC_EDT_FILE_OUT, strFileOut);
	GetDlgItemText(IDC_CMB_LANESDIRPOS, strNoLanesDirPos);
	GetDlgItemText(IDC_CMB_LANESDIRNEG, strNoLanesDirNeg);
	GetDlgItemText(IDC_CMB_TRAFFILE_LANESDIR1, strTrafFileNoLanesDirPos);
	GetDlgItemText(IDC_CMB_TRAFFILE_LANESDIR2, strTrafFileNoLanesDirNeg);

	if(strFileIn.IsEmpty())
	{
		strMessage = "Please select a file.";
		nID = IDC_EDT_FILE_IN;
		return;
	}

	if(strFileOut.IsEmpty())
	{
		strMessage = "Please specify a filename.";
		nID = IDC_EDT_FILE_OUT;
		return;
	}

	if(strNoLanesDirPos.IsEmpty())
	{
		strMessage = "Please specify the number of lanes.";
		nID = IDC_CMB_LANESDIRPOS;
		return;
	}

	if(strNoLanesDirNeg.IsEmpty())
	{
		strMessage = "Please specify the number of lanes.";
		nID = IDC_CMB_LANESDIRNEG;
		return;
	}

	if(strTrafFileNoLanesDirPos.IsEmpty())
	{
		strMessage = "Please specify the number of lanes.";
		nID = IDC_CMB_TRAFFILE_LANESDIR1;
		return;
	}

	if(strTrafFileNoLanesDirNeg.IsEmpty())
	{
		strMessage = "Please specify the number of lanes.";
		nID = IDC_CMB_TRAFFILE_LANESDIR2;
		return;
	}

	if(m_TrafFileNoLanesDirPos == 0 && m_TrafFileNoLanesDirNeg == 0)
	{
		strMessage = "There cannot be zero lanes in both directions";
		nID = IDC_CMB_TRAFFILE_LANESDIR1;
		return;
	}

	if(m_TrafFileNoLanesDirPos > m_NoLanesDirPos)
	{
		strMessage = "The number of simulation lanes must not \nbe less than that of the traffic file.";
		nID = IDC_CMB_LANESDIRPOS;
		return;
	}

	if(m_TrafFileNoLanesDirNeg > m_NoLanesDirNeg)
	{
		strMessage = "The number of simulation lanes must not \nbe less than that of the traffic file.";
		nID = IDC_CMB_LANESDIRNEG;
		return;
	}

	if(m_LocOutputDetectorDirPos > m_RoadLength)	// don't need to check < 0 since only positive nos allowed in edit ctrl
	{
		strMessage = "The output dector must be located on the road \n- please check the road length";
		nID = IDC_EDT_DIRPOSDETECTOR;
		return;
	}

	if(m_LocOutputDetectorDirNeg > m_RoadLength)
	{
		strMessage = "The output dector must be located on the road \n- please check the road length";
		nID = IDC_EDT_DIRNEGDETECTOR;
		return;
	}

	if(m_TrafFileNoLanesDirPos == 0 && m_NoLanesDirPos > 0)
	{
		strMessage = "For this direction, there will be no vehicles \nsince there are no lanes in the traffic file";
		nID = IDC_CMB_LANESDIRPOS;
		return;
	}

	if(m_TrafFileNoLanesDirNeg == 0 && m_NoLanesDirNeg > 0)
	{
		strMessage = "For this direction, there will be no vehicles \nsince there are no lanes in the traffic file";
		nID = IDC_CMB_LANESDIRNEG;
		return;
	}
}

BOOL CSimConfigDlg::OnInitDialog()
{
	CDialogExt::OnInitDialog();

	switch (m_FileType)
	{
		case SAFT:
			CheckDlgButton(IDC_RAD_SAFT,1);
			break;
		case CASTOR:
			CheckDlgButton(IDC_RAD_CASTOR,1);
			break;
		default:
			CheckDlgButton(IDC_RAD_CASTOR,1);
	}
	
	m_intDriveSide = 1;	// default to "Right"
	if(!m_DriveOnRight)
		m_intDriveSide = 0;	// but "Left" if needs be
	CComboBox * pCmb = (CComboBox*)GetDlgItem(IDC_CMB_DRIVESIDE);
	pCmb->SetCurSel(m_intDriveSide);

	return TRUE;
}

void CSimConfigDlg::OnBtnFileInPick() 
{
	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	//char CChildFrame::szFilters[] = ;

	CFileDialog FileDlg(
		TRUE,	// TRUE if File Open, FALSE if File Save As
		NULL,	// the default file extension
		NULL,	// the initial filename that appears
		OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,//flags for customizing the appearance
		"All Files (*.*)|*.*||",	// file filters
		this); // pointer to FileCialog's parent object
	
   if(FileDlg.DoModal() == IDOK)
   {
      m_FileIn = FileDlg.GetPathName();
	  UpdateData(FALSE); // The FALSE switches the direction of the DDX
   }
}

void CSimConfigDlg::OnBtnFileOutPick() 
{
	CFileDialog FileDlg(
		FALSE,			// TRUE if File Open, FALSE if File Save As
		_T("*.txt"),	// the default file extension
		NULL,			// the initial filename that appears
		OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,//flags for customizing the appearance
		"text files (*.txt) |*.txt|All Files (*.*)|*.*||",	// file filters
		this); // pointer to FileCialog's parent object
	
   if(FileDlg.DoModal() == IDOK)
   {
      m_FileOut = FileDlg.GetPathName();
	  UpdateData(FALSE); // The FALSE switches the direction of the DDX
   }
}

void CSimConfigDlg::OnBtnMetricsout() 
{
    BROWSEINFO bi = { 0 };
    bi.lpszTitle = _T("Pick a Directory");
    LPITEMIDLIST pidl = SHBrowseForFolder ( &bi );
    if ( pidl != 0 )
    {
        // get the name of the folder
        TCHAR path[MAX_PATH];
        if ( SHGetPathFromIDList ( pidl, path ) )
        {
            //TRACE("Selected Folder: %s\n", path );
			m_MetricsDir = path;
			m_MetricsDir += "\\";
			UpdateData(FALSE);
        }
		else
			MessageBox("Error in selecting folder - please type the name","EvolveTraffic",MB_OK | MB_ICONWARNING);

        // free memory used
        IMalloc * imalloc = 0;
        if ( SUCCEEDED( SHGetMalloc ( &imalloc )) )
        {
            imalloc->Free ( pidl );
            imalloc->Release ( );
        }
    }
}

void CSimConfigDlg::OnRadCastor() 
{
	m_FileType = CASTOR;
}

void CSimConfigDlg::OnRadSaft() 
{
	m_FileType = SAFT;
}

void CSimConfigDlg::OnSelchangeCmbDriveside() 
{
	CString str;
   	GetDlgItemText(IDC_CMB_DRIVESIDE, str);
	
	if(str == "Left")
		m_DriveOnRight = false;
	else
		m_DriveOnRight = true;	
}
