// StatDetector.cpp: implementation of the CStatDetector class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EvolveTraffic.h"
#include "StatDetector.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (CStatDetector, CObject, VERSION_NUMBER)

CStatDetector::CStatDetector()
{
	m_DetectorType	= METRICS_TYPE_FLOWDENSITY;
	m_DirPos		= true;
	m_VehicleType	= METRICS_VEH_ALL;
	m_TimeInterval	= 60;
	m_Location		= 1000;
}

CStatDetector::~CStatDetector()
{

}

void CStatDetector::Serialize(CArchive &ar)
{
    if (ar.IsStoring())
    {
        ar	<< m_DetectorType
			<< static_cast<int>(m_DirPos)	// because I read in an int below
			<< m_VehicleType
			<< m_TimeInterval
			<< m_Location;
    }
    else
	{
		int temp;
        ar	>> m_DetectorType
			>> temp
			>> m_VehicleType
			>> m_TimeInterval
			>> m_Location;

		m_DirPos = temp == 0 ? false : true;
	}
}

WORD CStatDetector::getDetectorType()
{
	return m_DetectorType;
}

bool CStatDetector::getDirPos()
{
	return m_DirPos;
}

WORD CStatDetector::getVehicleType()
{
	return m_VehicleType;
}

int CStatDetector::getTimeInterval()
{
	return m_TimeInterval;
}

int CStatDetector::getLocation()
{
	return m_Location;
}

void CStatDetector::setDetectorType(WORD type)
{
	m_DetectorType = type;
}

void CStatDetector::setDirPos(bool dirpos)
{
	m_DirPos = dirpos;
}

void CStatDetector::setVehicleType(WORD type)
{
	m_VehicleType = type;
}

void CStatDetector::setTimeInterval(int interval)
{
	m_TimeInterval = interval;
}

void CStatDetector::setLocation(int loc)
{
	m_Location = loc;
}

void CStatDetector::setMetricsDir(CString dir)
{
	m_MetricsDir = dir;
}

std::string CStatDetector::getStdStrMetricsDir()
{
	std::string str = (LPCTSTR)m_MetricsDir;
	return str;
}
