// Truck.cpp: implementation of the Truck class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Truck.h"

using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

	/** Default Constructor*/
Truck::Truck(){
/*
	HEAD	= 0;	DAY		= 0;	MONTH	= 0;	YEAR	= 5;	HOUR	= 0;
	MIN		= 0;	SEC		= 0;	hNDT	= 0;	SPEED	= 0;	GVW		= 0;
	LENGTH	= 0;	NAXLES	= 0;	DIRN	= 0;	LANE	= 0;	TRNS	= 0;
*/

}

	/** Default Destructor*/
Truck::~Truck()
{
	for(int i = 0; i < m_vAxles.size(); i++)
		delete m_vAxles.at(i);
	m_vAxles.clear();
}

	/** Parses the Truck's data into an array*/
void Truck::returnTruckData(int truckData[])
{

	truckData[0]	= m_Head;
	truckData[1]	= m_Day;
	truckData[2]	= m_Month;
	truckData[3]	= m_Year;
	truckData[4]	= m_Hour;
	truckData[5]	= m_Min;
	truckData[6]	= m_Sec;
	truckData[7]	= m_Hndt;	
	truckData[8]	= m_Velocity;	// must change to dm/s
	truckData[9]	= m_GVW;		// change to kg/100
	truckData[10]	= m_Length;		// change to dm
	truckData[11]	= m_NoAxles;
	truckData[12]	= m_intDir;		//m_DirPointsToRight == true ? 1 : 2;
	truckData[13]	= m_Lane;
	truckData[14]	= m_Trns;

	for(int i = 0; i <= 33; i++)
	{
		if( (truckData[i] < 0) || (truckData[i] > 9999) ) truckData[i] = 0;
	}
}

bool Truck::operator<(const Truck& x)
{
	double a = this->getTime();
	double b = x.getTime();
	return a < b;
}

bool Truck::operator==(Truck& x)
{
	const int N = 33;
	int truck1[N]; int truck2[N];
	returnTruckData(truck1);
	x.returnTruckData(truck2);

	bool same = true; int i = 0;
	while(same && i < N)
	{
		if(truck1[i] != truck2[i])
			same = false;
		i++;
	}
	return same;
}

	/** Creates a truck from a given SAFT string
	 *
	 * @param data The SAFT string of data
	 *
	 * This function takes in a string from a SAFT file and creates a truck
	 * based on the properties supplied by the data string
	 */
void Truck::createSAFTVehicle(std::string data)
{
	Vehicle::createSAFTVehicle(data);
	m_OverhangFront = 0.0;
	m_OverhangBack = 0.0;
}
	 
	/** Creates a truck from a given CASTOR string
	 *
	 * @param data The CASTOR string of data
	 *
	 * This function takes in a string from a CASTOR file and creates a truck
	 * based on the properties supplied by the data string
	 */
void Truck::createCASTORVehicle(std::string data)
{
	Vehicle::createCASTORVehicle(data);
	m_OverhangFront = 0.0;
	m_OverhangBack = 0.0;
}




