// Truck.h: interface for the Truck class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRUCK_H__4FAD4F73_3B9C_4D49_A94D_548AED8B7A7B__INCLUDED_)
#define AFX_TRUCK_H__4FAD4F73_3B9C_4D49_A94D_548AED8B7A7B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include <string>
#include <fstream>
#include <vector>

#include "Axle.h"
#include "Vehicle.h"

	/** A class to represent a Truck */

class Truck : public Vehicle 
{

public:	
	/** Default constructor */
	Truck();
	/** Default destructor */
	virtual ~Truck();

	void setAW(int i, double w);
	void setAS(int i, double s);
	int getNoAxles();
	double getAS(int i);
	double getAW(int i);
	bool operator==(Truck& x);
	bool operator<(const Truck& x);
	void returnTruckData(int truckData[]);
	
	void doSAFTData(char* pTruck);
	void doCASTORData(char* pTruck);
	void createSAFTVehicle(std::string data);
	void createCASTORVehicle(std::string data);
	void setDriver();
	
	void setGVW(double weight);

private:
	int getID();

	std::vector<Axle*> axles;
	double m_OverhangFront; 
	double m_OverhangBack;

};

#endif // !defined(AFX_TRUCK_H__4FAD4F73_3B9C_4D49_A94D_548AED8B7A7B__INCLUDED_)
